Index: branches/2521_ProblemRefactoring/HeuristicLab.Problems.VehicleRouting.Views/3.4/VRPProblemInstanceView.cs
===================================================================
--- branches/2521_ProblemRefactoring/HeuristicLab.Problems.VehicleRouting.Views/3.4/VRPProblemInstanceView.cs	(revision 17697)
+++ branches/2521_ProblemRefactoring/HeuristicLab.Problems.VehicleRouting.Views/3.4/VRPProblemInstanceView.cs	(revision 17698)
@@ -37,6 +37,6 @@
     }
 
-    private IVRPEncoding solution;
-    public IVRPEncoding Solution {
+    private IVRPEncodedSolution solution;
+    public IVRPEncodedSolution Solution {
       get {
         return solution;
Index: branches/2521_ProblemRefactoring/HeuristicLab.Problems.VehicleRouting/3.4/Analyzer/BestSolution/BestVRPSolutionAnalyzer.cs
===================================================================
--- branches/2521_ProblemRefactoring/HeuristicLab.Problems.VehicleRouting/3.4/Analyzer/BestSolution/BestVRPSolutionAnalyzer.cs	(revision 17697)
+++ branches/2521_ProblemRefactoring/HeuristicLab.Problems.VehicleRouting/3.4/Analyzer/BestSolution/BestVRPSolutionAnalyzer.cs	(revision 17698)
@@ -42,6 +42,6 @@
       get { return (ILookupParameter<IVRPProblemInstance>)Parameters["ProblemInstance"]; }
     }
-    public ScopeTreeLookupParameter<IVRPEncoding> VRPToursParameter {
-      get { return (ScopeTreeLookupParameter<IVRPEncoding>)Parameters["VRPTours"]; }
+    public ScopeTreeLookupParameter<IVRPEncodedSolution> VRPToursParameter {
+      get { return (ScopeTreeLookupParameter<IVRPEncodedSolution>)Parameters["VRPTours"]; }
     }
 
@@ -83,5 +83,5 @@
       : base() {
       Parameters.Add(new LookupParameter<IVRPProblemInstance>("ProblemInstance", "The problem instance."));
-      Parameters.Add(new ScopeTreeLookupParameter<IVRPEncoding>("VRPTours", "The VRP tours which should be evaluated."));
+      Parameters.Add(new ScopeTreeLookupParameter<IVRPEncodedSolution>("VRPTours", "The VRP tours which should be evaluated."));
 
       Parameters.Add(new LookupParameter<DoubleValue>("BestKnownQuality", "The quality of the best known solution of this VRP instance."));
@@ -119,5 +119,5 @@
     public override IOperation Apply() {
       IVRPProblemInstance problemInstance = ProblemInstanceParameter.ActualValue;
-      ItemArray<IVRPEncoding> solutions = VRPToursParameter.ActualValue;
+      ItemArray<IVRPEncodedSolution> solutions = VRPToursParameter.ActualValue;
       ResultCollection results = ResultsParameter.ActualValue;
 
@@ -127,8 +127,8 @@
 
       int i = qualities.Select((x, index) => new { index, x.Value }).OrderBy(x => x.Value).First().index;
-      IVRPEncoding best = solutions[i].Clone() as IVRPEncoding;
+      IVRPEncodedSolution best = solutions[i].Clone() as IVRPEncodedSolution;
       VRPSolution solution = BestSolutionParameter.ActualValue;
       if (solution == null) {
-        solution = new VRPSolution(problemInstance, best.Clone() as IVRPEncoding, new DoubleValue(qualities[i].Value));
+        solution = new VRPSolution(problemInstance, best.Clone() as IVRPEncodedSolution, new DoubleValue(qualities[i].Value));
         BestSolutionParameter.ActualValue = solution;
         results.Add(new Result("Best VRP Solution", solution));
@@ -140,5 +140,5 @@
         if (qualities[i].Value <= eval.Quality) {
           solution.ProblemInstance = problemInstance;
-          solution.Solution = best.Clone() as IVRPEncoding;
+          solution.Solution = best.Clone() as IVRPEncodedSolution;
           solution.Quality.Value = qualities[i].Value;
           (results["Best VRP Solution Distance"].Value as DoubleValue).Value = distances[i].Value;
@@ -150,8 +150,8 @@
       if (idx != null) {
         int j = idx.index;
-        IVRPEncoding bestFeasible = solutions[j].Clone() as IVRPEncoding;
+        IVRPEncodedSolution bestFeasible = solutions[j].Clone() as IVRPEncodedSolution;
         VRPSolution validSolution = BestValidSolutionParameter.ActualValue;
         if (validSolution == null) {
-          validSolution = new VRPSolution(problemInstance, best.Clone() as IVRPEncoding, new DoubleValue(qualities[j].Value));
+          validSolution = new VRPSolution(problemInstance, best.Clone() as IVRPEncodedSolution, new DoubleValue(qualities[j].Value));
           BestValidSolutionParameter.ActualValue = validSolution;
           if (results.ContainsKey("Best valid VRP Solution"))
@@ -166,5 +166,5 @@
             if (ProblemInstanceParameter.ActualValue.Feasible(best)) {
               validSolution.ProblemInstance = problemInstance;
-              validSolution.Solution = best.Clone() as IVRPEncoding;
+              validSolution.Solution = best.Clone() as IVRPEncodedSolution;
               validSolution.Quality.Value = qualities[j].Value;
               (results["Best valid VRP Solution Distance"].Value as DoubleValue).Value = distances[j].Value;
Index: branches/2521_ProblemRefactoring/HeuristicLab.Problems.VehicleRouting/3.4/Analyzer/BestSolution/Capacitated/BestCapacitatedVRPSolutionAnalyzer.cs
===================================================================
--- branches/2521_ProblemRefactoring/HeuristicLab.Problems.VehicleRouting/3.4/Analyzer/BestSolution/Capacitated/BestCapacitatedVRPSolutionAnalyzer.cs	(revision 17697)
+++ branches/2521_ProblemRefactoring/HeuristicLab.Problems.VehicleRouting/3.4/Analyzer/BestSolution/Capacitated/BestCapacitatedVRPSolutionAnalyzer.cs	(revision 17698)
@@ -42,6 +42,6 @@
       get { return (ILookupParameter<IVRPProblemInstance>)Parameters["ProblemInstance"]; }
     }
-    public ScopeTreeLookupParameter<IVRPEncoding> VRPToursParameter {
-      get { return (ScopeTreeLookupParameter<IVRPEncoding>)Parameters["VRPTours"]; }
+    public ScopeTreeLookupParameter<IVRPEncodedSolution> VRPToursParameter {
+      get { return (ScopeTreeLookupParameter<IVRPEncodedSolution>)Parameters["VRPTours"]; }
     }
     public ScopeTreeLookupParameter<DoubleValue> QualityParameter {
@@ -70,5 +70,5 @@
       : base() {
       Parameters.Add(new LookupParameter<IVRPProblemInstance>("ProblemInstance", "The problem instance."));
-      Parameters.Add(new ScopeTreeLookupParameter<IVRPEncoding>("VRPTours", "The VRP tours which should be evaluated."));
+      Parameters.Add(new ScopeTreeLookupParameter<IVRPEncodedSolution>("VRPTours", "The VRP tours which should be evaluated."));
       Parameters.Add(new ScopeTreeLookupParameter<DoubleValue>("Quality", "The qualities of the VRP solutions which should be analyzed."));
 
@@ -89,5 +89,5 @@
     public override IOperation Apply() {
       IVRPProblemInstance problemInstance = ProblemInstanceParameter.ActualValue;
-      ItemArray<IVRPEncoding> solutions = VRPToursParameter.ActualValue;
+      ItemArray<IVRPEncodedSolution> solutions = VRPToursParameter.ActualValue;
       ResultCollection results = ResultsParameter.ActualValue;
 
Index: branches/2521_ProblemRefactoring/HeuristicLab.Problems.VehicleRouting/3.4/Analyzer/BestSolution/PickupAndDelivery/BestPickupAndDeliveryVRPSolutionAnalyzer.cs
===================================================================
--- branches/2521_ProblemRefactoring/HeuristicLab.Problems.VehicleRouting/3.4/Analyzer/BestSolution/PickupAndDelivery/BestPickupAndDeliveryVRPSolutionAnalyzer.cs	(revision 17697)
+++ branches/2521_ProblemRefactoring/HeuristicLab.Problems.VehicleRouting/3.4/Analyzer/BestSolution/PickupAndDelivery/BestPickupAndDeliveryVRPSolutionAnalyzer.cs	(revision 17698)
@@ -42,6 +42,6 @@
       get { return (ILookupParameter<IVRPProblemInstance>)Parameters["ProblemInstance"]; }
     }
-    public ScopeTreeLookupParameter<IVRPEncoding> VRPToursParameter {
-      get { return (ScopeTreeLookupParameter<IVRPEncoding>)Parameters["VRPTours"]; }
+    public ScopeTreeLookupParameter<IVRPEncodedSolution> VRPToursParameter {
+      get { return (ScopeTreeLookupParameter<IVRPEncodedSolution>)Parameters["VRPTours"]; }
     }
     public ScopeTreeLookupParameter<DoubleValue> QualityParameter {
@@ -70,5 +70,5 @@
       : base() {
       Parameters.Add(new LookupParameter<IVRPProblemInstance>("ProblemInstance", "The problem instance."));
-      Parameters.Add(new ScopeTreeLookupParameter<IVRPEncoding>("VRPTours", "The VRP tours which should be evaluated."));
+      Parameters.Add(new ScopeTreeLookupParameter<IVRPEncodedSolution>("VRPTours", "The VRP tours which should be evaluated."));
       Parameters.Add(new ScopeTreeLookupParameter<DoubleValue>("Quality", "The qualities of the VRP solutions which should be analyzed."));
 
@@ -89,5 +89,5 @@
     public override IOperation Apply() {
       IVRPProblemInstance problemInstance = ProblemInstanceParameter.ActualValue;
-      ItemArray<IVRPEncoding> solutions = VRPToursParameter.ActualValue;
+      ItemArray<IVRPEncodedSolution> solutions = VRPToursParameter.ActualValue;
       ResultCollection results = ResultsParameter.ActualValue;
 
@@ -97,5 +97,5 @@
       int i = qualities.Select((x, index) => new { index, x.Value }).OrderBy(x => x.Value).First().index;
 
-      IVRPEncoding best = solutions[i] as IVRPEncoding;
+      IVRPEncodedSolution best = solutions[i] as IVRPEncodedSolution;
       VRPSolution solution = BestSolutionParameter.ActualValue;
       if (solution != null) {
Index: branches/2521_ProblemRefactoring/HeuristicLab.Problems.VehicleRouting/3.4/Analyzer/BestSolution/TimeWindowed/BestTimeWindowedVRPSolutionAnalyzer.cs
===================================================================
--- branches/2521_ProblemRefactoring/HeuristicLab.Problems.VehicleRouting/3.4/Analyzer/BestSolution/TimeWindowed/BestTimeWindowedVRPSolutionAnalyzer.cs	(revision 17697)
+++ branches/2521_ProblemRefactoring/HeuristicLab.Problems.VehicleRouting/3.4/Analyzer/BestSolution/TimeWindowed/BestTimeWindowedVRPSolutionAnalyzer.cs	(revision 17698)
@@ -42,6 +42,6 @@
       get { return (ILookupParameter<IVRPProblemInstance>)Parameters["ProblemInstance"]; }
     }
-    public ScopeTreeLookupParameter<IVRPEncoding> VRPToursParameter {
-      get { return (ScopeTreeLookupParameter<IVRPEncoding>)Parameters["VRPTours"]; }
+    public ScopeTreeLookupParameter<IVRPEncodedSolution> VRPToursParameter {
+      get { return (ScopeTreeLookupParameter<IVRPEncodedSolution>)Parameters["VRPTours"]; }
     }
     public ScopeTreeLookupParameter<DoubleValue> QualityParameter {
@@ -73,5 +73,5 @@
       : base() {
       Parameters.Add(new LookupParameter<IVRPProblemInstance>("ProblemInstance", "The problem instance."));
-      Parameters.Add(new ScopeTreeLookupParameter<IVRPEncoding>("VRPTours", "The VRP tours which should be evaluated."));
+      Parameters.Add(new ScopeTreeLookupParameter<IVRPEncodedSolution>("VRPTours", "The VRP tours which should be evaluated."));
       Parameters.Add(new ScopeTreeLookupParameter<DoubleValue>("Quality", "The qualities of the VRP solutions which should be analyzed."));
 
@@ -93,5 +93,5 @@
     public override IOperation Apply() {
       IVRPProblemInstance problemInstance = ProblemInstanceParameter.ActualValue;
-      ItemArray<IVRPEncoding> solutions = VRPToursParameter.ActualValue;
+      ItemArray<IVRPEncodedSolution> solutions = VRPToursParameter.ActualValue;
       ResultCollection results = ResultsParameter.ActualValue;
 
Index: branches/2521_ProblemRefactoring/HeuristicLab.Problems.VehicleRouting/3.4/Analyzer/ConstraintRelaxation/Capacitated/CapacityRelaxationVRPAnalyzer.cs
===================================================================
--- branches/2521_ProblemRefactoring/HeuristicLab.Problems.VehicleRouting/3.4/Analyzer/ConstraintRelaxation/Capacitated/CapacityRelaxationVRPAnalyzer.cs	(revision 17697)
+++ branches/2521_ProblemRefactoring/HeuristicLab.Problems.VehicleRouting/3.4/Analyzer/ConstraintRelaxation/Capacitated/CapacityRelaxationVRPAnalyzer.cs	(revision 17698)
@@ -40,6 +40,6 @@
       get { return (ILookupParameter<IVRPProblemInstance>)Parameters["ProblemInstance"]; }
     }
-    public ScopeTreeLookupParameter<IVRPEncoding> VRPToursParameter {
-      get { return (ScopeTreeLookupParameter<IVRPEncoding>)Parameters["VRPTours"]; }
+    public ScopeTreeLookupParameter<IVRPEncodedSolution> VRPToursParameter {
+      get { return (ScopeTreeLookupParameter<IVRPEncodedSolution>)Parameters["VRPTours"]; }
     }
     public ScopeTreeLookupParameter<DoubleValue> QualityParameter {
@@ -78,5 +78,5 @@
       : base() {
       Parameters.Add(new LookupParameter<IVRPProblemInstance>("ProblemInstance", "The problem instance."));
-      Parameters.Add(new ScopeTreeLookupParameter<IVRPEncoding>("VRPTours", "The VRP tours which should be evaluated."));
+      Parameters.Add(new ScopeTreeLookupParameter<IVRPEncodedSolution>("VRPTours", "The VRP tours which should be evaluated."));
       Parameters.Add(new ScopeTreeLookupParameter<DoubleValue>("Quality", "The qualities of the VRP solutions which should be analyzed."));
 
Index: branches/2521_ProblemRefactoring/HeuristicLab.Problems.VehicleRouting/3.4/Analyzer/ConstraintRelaxation/PickupAndDelivery/PickupViolationsRelaxationVRPAnalyzer.cs
===================================================================
--- branches/2521_ProblemRefactoring/HeuristicLab.Problems.VehicleRouting/3.4/Analyzer/ConstraintRelaxation/PickupAndDelivery/PickupViolationsRelaxationVRPAnalyzer.cs	(revision 17697)
+++ branches/2521_ProblemRefactoring/HeuristicLab.Problems.VehicleRouting/3.4/Analyzer/ConstraintRelaxation/PickupAndDelivery/PickupViolationsRelaxationVRPAnalyzer.cs	(revision 17698)
@@ -40,6 +40,6 @@
       get { return (ILookupParameter<IVRPProblemInstance>)Parameters["ProblemInstance"]; }
     }
-    public ScopeTreeLookupParameter<IVRPEncoding> VRPToursParameter {
-      get { return (ScopeTreeLookupParameter<IVRPEncoding>)Parameters["VRPTours"]; }
+    public ScopeTreeLookupParameter<IVRPEncodedSolution> VRPToursParameter {
+      get { return (ScopeTreeLookupParameter<IVRPEncodedSolution>)Parameters["VRPTours"]; }
     }
     public ScopeTreeLookupParameter<DoubleValue> QualityParameter {
@@ -78,5 +78,5 @@
       : base() {
       Parameters.Add(new LookupParameter<IVRPProblemInstance>("ProblemInstance", "The problem instance."));
-      Parameters.Add(new ScopeTreeLookupParameter<IVRPEncoding>("VRPTours", "The VRP tours which should be evaluated."));
+      Parameters.Add(new ScopeTreeLookupParameter<IVRPEncodedSolution>("VRPTours", "The VRP tours which should be evaluated."));
       Parameters.Add(new ScopeTreeLookupParameter<DoubleValue>("Quality", "The qualities of the VRP solutions which should be analyzed."));
 
Index: branches/2521_ProblemRefactoring/HeuristicLab.Problems.VehicleRouting/3.4/Analyzer/ConstraintRelaxation/TimeWindowed/TimeWindowRelaxationVRPAnalyzer.cs
===================================================================
--- branches/2521_ProblemRefactoring/HeuristicLab.Problems.VehicleRouting/3.4/Analyzer/ConstraintRelaxation/TimeWindowed/TimeWindowRelaxationVRPAnalyzer.cs	(revision 17697)
+++ branches/2521_ProblemRefactoring/HeuristicLab.Problems.VehicleRouting/3.4/Analyzer/ConstraintRelaxation/TimeWindowed/TimeWindowRelaxationVRPAnalyzer.cs	(revision 17698)
@@ -40,6 +40,6 @@
       get { return (ILookupParameter<IVRPProblemInstance>)Parameters["ProblemInstance"]; }
     }
-    public ScopeTreeLookupParameter<IVRPEncoding> VRPToursParameter {
-      get { return (ScopeTreeLookupParameter<IVRPEncoding>)Parameters["VRPTours"]; }
+    public ScopeTreeLookupParameter<IVRPEncodedSolution> VRPToursParameter {
+      get { return (ScopeTreeLookupParameter<IVRPEncodedSolution>)Parameters["VRPTours"]; }
     }
     public ScopeTreeLookupParameter<DoubleValue> QualityParameter {
@@ -78,5 +78,5 @@
       : base() {
       Parameters.Add(new LookupParameter<IVRPProblemInstance>("ProblemInstance", "The problem instance."));
-      Parameters.Add(new ScopeTreeLookupParameter<IVRPEncoding>("VRPTours", "The VRP tours which should be evaluated."));
+      Parameters.Add(new ScopeTreeLookupParameter<IVRPEncodedSolution>("VRPTours", "The VRP tours which should be evaluated."));
       Parameters.Add(new ScopeTreeLookupParameter<DoubleValue>("Quality", "The qualities of the VRP solutions which should be analyzed."));
 
Index: branches/2521_ProblemRefactoring/HeuristicLab.Problems.VehicleRouting/3.4/Analyzer/VRPSolution.cs
===================================================================
--- branches/2521_ProblemRefactoring/HeuristicLab.Problems.VehicleRouting/3.4/Analyzer/VRPSolution.cs	(revision 17697)
+++ branches/2521_ProblemRefactoring/HeuristicLab.Problems.VehicleRouting/3.4/Analyzer/VRPSolution.cs	(revision 17698)
@@ -53,6 +53,6 @@
     }
     [Storable]
-    private IVRPEncoding solution;
-    public IVRPEncoding Solution {
+    private IVRPEncodedSolution solution;
+    public IVRPEncodedSolution Solution {
       get { return solution; }
       set {
@@ -81,5 +81,5 @@
     public VRPSolution() : base() { }
 
-    public VRPSolution(IVRPProblemInstance problemInstance, IVRPEncoding solution, DoubleValue quality)
+    public VRPSolution(IVRPProblemInstance problemInstance, IVRPEncodedSolution solution, DoubleValue quality)
       : base() {
       this.problemInstance = problemInstance;
@@ -106,5 +106,5 @@
     private VRPSolution(VRPSolution original, Cloner cloner)
       : base(original, cloner) {
-      this.solution = (IVRPEncoding)cloner.Clone(original.solution);
+      this.solution = (IVRPEncodedSolution)cloner.Clone(original.solution);
       this.quality = (DoubleValue)cloner.Clone(original.quality);
 
Index: branches/2521_ProblemRefactoring/HeuristicLab.Problems.VehicleRouting/3.4/Encodings/Alba/AlbaEncodedSolution.cs
===================================================================
--- branches/2521_ProblemRefactoring/HeuristicLab.Problems.VehicleRouting/3.4/Encodings/Alba/AlbaEncodedSolution.cs	(revision 17698)
+++ branches/2521_ProblemRefactoring/HeuristicLab.Problems.VehicleRouting/3.4/Encodings/Alba/AlbaEncodedSolution.cs	(revision 17698)
@@ -0,0 +1,178 @@
+﻿#region License Information
+/* HeuristicLab
+ * Copyright (C) Heuristic and Evolutionary Algorithms Laboratory (HEAL)
+ *
+ * This file is part of HeuristicLab.
+ *
+ * HeuristicLab is free software: you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License as published by
+ * the Free Software Foundation, either version 3 of the License, or
+ * (at your option) any later version.
+ *
+ * HeuristicLab is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ * GNU General Public License for more details.
+ *
+ * You should have received a copy of the GNU General Public License
+ * along with HeuristicLab. If not, see <http://www.gnu.org/licenses/>.
+ */
+#endregion
+
+using System.Collections.Generic;
+using HEAL.Attic;
+using HeuristicLab.Common;
+using HeuristicLab.Core;
+using HeuristicLab.Data;
+using HeuristicLab.Encodings.PermutationEncoding;
+using HeuristicLab.Problems.VehicleRouting.Interfaces;
+
+namespace HeuristicLab.Problems.VehicleRouting.Encodings.Alba {
+  [Item("AlbaEncodedSolution", "Represents an Alba encoded solution for the VRP. It is implemented as described in Alba, E. and Dorronsoro, B. (2004). Solving the Vehicle Routing Problem by Using Cellular Genetic Algorithms.")]
+  [StorableType("8BB9735D-8371-46C1-B843-A6864B2ACDA5")]
+  public class AlbaEncodedSolution : General.PermutationEncoding {
+    #region IVRPEncoding Members
+    public override List<Tour> GetTours() {
+      Repair();
+      List<Tour> result = new List<Tour>();
+
+      int cities = ProblemInstance.Cities.Value;
+
+      Tour tour = new Tour();
+      for (int i = 0; i < this.array.Length; i++) {
+        if (this.array[i] >= cities) {
+          if (tour.Stops.Count > 0) {
+            result.Add(tour);
+
+            tour = new Tour();
+          }
+        } else {
+          tour.Stops.Add(this.array[i] + 1);
+        }
+      }
+
+      if (tour.Stops.Count > 0) {
+        result.Add(tour);
+      }
+
+      return result;
+    }
+
+    public override int GetVehicleAssignment(int tour) {
+      int vehicleAssignment = -1;
+      Tour currentTour = GetTours()[tour];
+
+      int lastStop = currentTour.Stops[
+        currentTour.Stops.Count - 1] - 1;
+
+      int lastStopIndex = this.IndexOf(lastStop);
+
+      if (lastStopIndex == this.Length - 1) {
+        int i = this.Length - 1;
+
+        while (vehicleAssignment == -1) {
+          if (this.array[i] >= ProblemInstance.Cities.Value) {
+            vehicleAssignment = this.array[i] - ProblemInstance.Cities.Value;
+          }
+
+          i--;
+        }
+      } else
+        vehicleAssignment = this[lastStopIndex + 1] - this.ProblemInstance.Cities.Value;
+
+      return vehicleAssignment;
+    }
+    #endregion
+
+    public void Repair() {
+      int cities = ProblemInstance.Cities.Value;
+
+      if (this[this.Length - 1] < cities) {
+        int index = this.Length - 2;
+        while (this[index] < cities) {
+          index--;
+        }
+
+        int vehicle = this[index];
+        for (int i = index; i < this.Length - 1; i++)
+          this[i] = this[i + 1];
+        this[Length - 1] = vehicle;
+      }
+    }
+
+    public AlbaEncodedSolution(Permutation permutation, IVRPProblemInstance instance)
+      : base(permutation, instance) {
+    }
+
+    [StorableConstructor]
+    protected AlbaEncodedSolution(StorableConstructorFlag _) : base(_) {
+    }
+
+    public override IDeepCloneable Clone(Cloner cloner) {
+      return new AlbaEncodedSolution(this, cloner);
+    }
+
+    protected AlbaEncodedSolution(AlbaEncodedSolution original, Cloner cloner)
+      : base(original, cloner) {
+    }
+
+    public static AlbaEncodedSolution ConvertFrom(List<int> routeParam, IVRPProblemInstance instance) {
+      List<int> route = new List<int>(routeParam);
+
+      int cities = instance.Cities.Value;
+
+      for (int i = 0; i < route.Count; i++) {
+        if (route[i] <= 0) {
+          int vehicle = -route[i];
+          route[i] = cities + vehicle;
+        } else {
+          route[i] = route[i] - 1;
+        }
+      }
+
+      return new AlbaEncodedSolution(
+        new Permutation(PermutationTypes.RelativeUndirected, route.ToArray()),
+        instance);
+    }
+
+    public static AlbaEncodedSolution ConvertFrom(IVRPEncodedSolution encoding, IVRPProblemInstance instance) {
+      List<Tour> tours = encoding.GetTours();
+
+      int cities = 0;
+      foreach (Tour tour in tours) {
+        cities += tour.Stops.Count;
+      }
+
+      int emptyVehicles = instance.Vehicles.Value - tours.Count;
+
+      int[] array = new int[cities + tours.Count + emptyVehicles];
+      int delimiter = 0;
+      int arrayIndex = 0;
+
+      foreach (Tour tour in tours) {
+        foreach (int city in tour.Stops) {
+          array[arrayIndex] = city - 1;
+          arrayIndex++;
+        }
+
+        if (arrayIndex != array.Length) {
+          array[arrayIndex] = cities + encoding.GetVehicleAssignment(delimiter);
+
+          delimiter++;
+          arrayIndex++;
+        }
+      }
+
+      for (int i = 0; i < emptyVehicles; i++) {
+        array[arrayIndex] = cities + encoding.GetVehicleAssignment(delimiter);
+
+        delimiter++;
+        arrayIndex++;
+      }
+
+      AlbaEncodedSolution solution = new AlbaEncodedSolution(new Permutation(PermutationTypes.RelativeUndirected, new IntArray(array)), instance);
+
+      return solution;
+    }
+  }
+}
Index: branches/2521_ProblemRefactoring/HeuristicLab.Problems.VehicleRouting/3.4/Encodings/Alba/AlbaEncoding.cs
===================================================================
--- branches/2521_ProblemRefactoring/HeuristicLab.Problems.VehicleRouting/3.4/Encodings/Alba/AlbaEncoding.cs	(revision 17697)
+++ branches/2521_ProblemRefactoring/HeuristicLab.Problems.VehicleRouting/3.4/Encodings/Alba/AlbaEncoding.cs	(revision 17698)
@@ -20,159 +20,60 @@
 #endregion
 
+using System;
 using System.Collections.Generic;
+using System.Linq;
+using HEAL.Attic;
 using HeuristicLab.Common;
 using HeuristicLab.Core;
-using HeuristicLab.Data;
-using HeuristicLab.Encodings.PermutationEncoding;
-using HEAL.Attic;
-using HeuristicLab.Problems.VehicleRouting.Interfaces;
+using HeuristicLab.Optimization;
+using HeuristicLab.PluginInfrastructure;
 
 namespace HeuristicLab.Problems.VehicleRouting.Encodings.Alba {
-  [Item("AlbaEncoding", "Represents an Alba encoding of VRP solutions. It is implemented as described in Alba, E. and Dorronsoro, B. (2004). Solving the Vehicle Routing Problem by Using Cellular Genetic Algorithms.")]
-  [StorableType("8BB9735D-8371-46C1-B843-A6864B2ACDA5")]
-  public class AlbaEncoding : General.PermutationEncoding {
-    #region IVRPEncoding Members
-    public override List<Tour> GetTours() {
-      Repair();
-      List<Tour> result = new List<Tour>();
+  [Item("AlbaEncoding", "Represents the encoding for Alba encoded solutions.")]
+  [StorableType("9ff9f959-31d2-44e5-8a5e-b122220535c2")]
+  public class AlbaEncoding : Encoding<AlbaEncodedSolution>, IVRPEncoding<AlbaEncodedSolution> {
 
-      int cities = ProblemInstance.Cities.Value;
-
-      Tour tour = new Tour();
-      for (int i = 0; i < this.array.Length; i++) {
-        if (this.array[i] >= cities) {
-          if (tour.Stops.Count > 0) {
-            result.Add(tour);
-
-            tour = new Tour();
-          }
-        } else {
-          tour.Stops.Add(this.array[i] + 1);
-        }
-      }
-
-      if (tour.Stops.Count > 0) {
-        result.Add(tour);
-      }
-
-      return result;
+    [StorableConstructor]
+    private AlbaEncoding(StorableConstructorFlag _) : base(_) { }
+    [StorableHook(HookType.AfterDeserialization)]
+    private void AfterDeserialization() {
+      DiscoverOperators();
     }
 
-    public override int GetVehicleAssignment(int tour) {
-      int vehicleAssignment = -1;
-      Tour currentTour = GetTours()[tour];
+    public override IDeepCloneable Clone(Cloner cloner) { return new AlbaEncoding(this, cloner); }
+    private AlbaEncoding(AlbaEncoding original, Cloner cloner) : base(original, cloner) { }
 
-      int lastStop = currentTour.Stops[
-        currentTour.Stops.Count - 1] - 1;
 
-      int lastStopIndex = this.IndexOf(lastStop);
+    public AlbaEncoding() : this("VRPTours") { }
+    public AlbaEncoding(string name) : base(name) {
+      DiscoverOperators();
+    }
 
-      if (lastStopIndex == this.Length - 1) {
-        int i = this.Length - 1;
+    #region Operator Discovery
+    private static readonly IEnumerable<Type> encodingSpecificOperatorTypes;
+    static AlbaEncoding() {
+      encodingSpecificOperatorTypes = new List<Type>() {
+          typeof (IAlbaOperator)
+      };
+    }
+    private void DiscoverOperators() {
+      var assembly = typeof(IAlbaOperator).Assembly;
+      var discoveredTypes = ApplicationManager.Manager.GetTypes(encodingSpecificOperatorTypes, assembly, true, false, false);
+      var operators = discoveredTypes.Select(t => (IOperator)Activator.CreateInstance(t));
+      var newOperators = operators.Except(Operators, new TypeEqualityComparer<IOperator>()).ToList();
 
-        while (vehicleAssignment == -1) {
-          if (this.array[i] >= ProblemInstance.Cities.Value) {
-            vehicleAssignment = this.array[i] - ProblemInstance.Cities.Value;
-          }
-
-          i--;
-        }
-      } else
-        vehicleAssignment = this[lastStopIndex + 1] - this.ProblemInstance.Cities.Value;
-
-      return vehicleAssignment;
+      ConfigureOperators(newOperators);
+      foreach (var @operator in newOperators)
+        AddOperator(@operator);
     }
     #endregion
 
-    public void Repair() {
-      int cities = ProblemInstance.Cities.Value;
-
-      if (this[this.Length - 1] < cities) {
-        int index = this.Length - 2;
-        while (this[index] < cities) {
-          index--;
-        }
-
-        int vehicle = this[index];
-        for (int i = index; i < this.Length - 1; i++)
-          this[i] = this[i + 1];
-        this[Length - 1] = vehicle;
-      }
+    public override void ConfigureOperators(IEnumerable<IItem> operators) {
+      base.ConfigureOperators(operators);
     }
 
-    public AlbaEncoding(Permutation permutation, IVRPProblemInstance instance)
-      : base(permutation, instance) {
-    }
+    #region specific operator wiring
 
-    [StorableConstructor]
-    protected AlbaEncoding(StorableConstructorFlag _) : base(_) {
-    }
-
-    public override IDeepCloneable Clone(Cloner cloner) {
-      return new AlbaEncoding(this, cloner);
-    }
-
-    protected AlbaEncoding(AlbaEncoding original, Cloner cloner)
-      : base(original, cloner) {
-    }
-
-    public static AlbaEncoding ConvertFrom(List<int> routeParam, IVRPProblemInstance instance) {
-      List<int> route = new List<int>(routeParam);
-
-      int cities = instance.Cities.Value;
-
-      for (int i = 0; i < route.Count; i++) {
-        if (route[i] <= 0) {
-          int vehicle = -route[i];
-          route[i] = cities + vehicle;
-        } else {
-          route[i] = route[i] - 1;
-        }
-      }
-
-      return new AlbaEncoding(
-        new Permutation(PermutationTypes.RelativeUndirected, route.ToArray()),
-        instance);
-    }
-
-    public static AlbaEncoding ConvertFrom(IVRPEncoding encoding, IVRPProblemInstance instance) {
-      List<Tour> tours = encoding.GetTours();
-
-      int cities = 0;
-      foreach (Tour tour in tours) {
-        cities += tour.Stops.Count;
-      }
-
-      int emptyVehicles = instance.Vehicles.Value - tours.Count;
-
-      int[] array = new int[cities + tours.Count + emptyVehicles];
-      int delimiter = 0;
-      int arrayIndex = 0;
-
-      foreach (Tour tour in tours) {
-        foreach (int city in tour.Stops) {
-          array[arrayIndex] = city - 1;
-          arrayIndex++;
-        }
-
-        if (arrayIndex != array.Length) {
-          array[arrayIndex] = cities + encoding.GetVehicleAssignment(delimiter);
-
-          delimiter++;
-          arrayIndex++;
-        }
-      }
-
-      for (int i = 0; i < emptyVehicles; i++) {
-        array[arrayIndex] = cities + encoding.GetVehicleAssignment(delimiter);
-
-        delimiter++;
-        arrayIndex++;
-      }
-
-      AlbaEncoding solution = new AlbaEncoding(new Permutation(PermutationTypes.RelativeUndirected, new IntArray(array)), instance);
-
-      return solution;
-    }
+    #endregion
   }
 }
Index: branches/2521_ProblemRefactoring/HeuristicLab.Problems.VehicleRouting/3.4/Encodings/Alba/Creators/AlbaCreator.cs
===================================================================
--- branches/2521_ProblemRefactoring/HeuristicLab.Problems.VehicleRouting/3.4/Encodings/Alba/Creators/AlbaCreator.cs	(revision 17697)
+++ branches/2521_ProblemRefactoring/HeuristicLab.Problems.VehicleRouting/3.4/Encodings/Alba/Creators/AlbaCreator.cs	(revision 17698)
@@ -20,7 +20,8 @@
 #endregion
 
+using HEAL.Attic;
 using HeuristicLab.Common;
 using HeuristicLab.Core;
-using HEAL.Attic;
+using HeuristicLab.Optimization;
 using HeuristicLab.Problems.VehicleRouting.Encodings.General;
 using HeuristicLab.Problems.VehicleRouting.Interfaces;
@@ -29,5 +30,5 @@
   [Item("AlbaCreator", "A VRP creator.")]
   [StorableType("95DC1B24-02C9-4AF0-8A00-21A47AFB9E39")]
-  public abstract class AlbaCreator : VRPCreator, IAlbaOperator, IVRPCreator {
+  public abstract class AlbaCreator : VRPCreator, IAlbaOperator, IVRPCreator, ISolutionCreator<AlbaEncodedSolution> {
     public override bool CanChangeName {
       get { return false; }
@@ -46,5 +47,5 @@
 
     public override IOperation InstrumentedApply() {
-      (VRPToursParameter.ActualValue as AlbaEncoding).Repair();
+      (VRPToursParameter.ActualValue as AlbaEncodedSolution).Repair();
 
       return base.InstrumentedApply();
